
// ============================================= //
//    Cash Mod by Clockturn                      //
//  Credits:                                     //
//   NiXiLL - Teaching me to script, basically   //
//   Iban   - I kinda used his drop cash stuff.  //
//              Shh. Nobody tell him.            //
//   Darren - Nagging me to make it so I did     //
// ============================================= //

$Cash::Currency = "$";
$Cash::CurrencyBefore = 1;
$Cash::CurrencyColor = "007700";
$Cash::CurrencyItemColor = "0 0.6 0 1";
$Cash::CurrencyName = "Cash";
$Cash::DefaultBank = 150;
$Cash::DefaultCash = 25;
$Cash::DropOnDeath = 1;
$Cash::MaxDrop = 1000;
$Cash::SaveTime = 5;
$Cash::SaveIncome = 0;
$Cash::SaveInterest = 1;
$Cash::BrickCostPerVolume = 1;
if(isFile("config/server/CashPrefs.cs"))
{
	exec("config/server/CashPrefs.cs");
} else {
	export("$Cash::*","config/server/CashPrefs.cs");
}
if(isFile("add-ons/System_ReturnToBlockland/server.cs") && !$CashRTB)
{
	if(!$RTB::RTBS_ServerControl)
	{
		exec("add-ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}
	RTB_registerPref("Currency Name","Cash","$Cash::CurrencyName","string 16","Cashmod",$Cash::CurrencyName,0,0);
	RTB_registerPref("Currency Icon","Cash","$Cash::Currency","string 2","Cashmod",$Cash::Currency,0,0);
	RTB_registerPref("Currency Color","Cash","$Cash::CurrencyColor","string 6","Cashmod",$Cash::CurrencyColor,0,0);
	RTB_registerPref("Currency Icon Before","Cash","$Cash::CurrencyBefore","bool","Cashmod",$Cash::CurrencyBefore,0,0);
	RTB_registerPref("Currency Item Color","Cash","$Cash::CurrencyItemColor","string 24","Cashmod",$Cash::CurrencyItemColor,1,0);
	RTB_registerPref("New Wallet","Cash","$Cash::DefaultCash","int 0 1000","Cashmod",$Cash::DefaultCash,0,0);
	RTB_registerPref("New Bank","Cash","$Cash::DefaultBank","int 0 1000","Cashmod",$Cash::DefaultBank,0,0);
	RTB_registerPref("Drop Cash on Death","Cash","$Cash::DropOnDeath","bool","Cashmod",$Cash::DropOnDeath,0,0);
	RTB_registerPref("Maximum Manual Drop","Cash","$Cash::MaxDrop","int 0 5000","Cashmod",$Cash::MaxDrop,0,0);
	RTB_registerPref("Save Tick Time","Cash","$Cash::SaveTime","int 2 30","Cashmod",$Cash::SaveTime,0,0);
	RTB_registerPref("Save Tick Income","Cash","$Cash::SaveIncome","int 0 100","Cashmod",$Cash::SaveIncome,0,0);
	RTB_registerPref("Save Tick Interest","Cash","$Cash::SaveInterest","int 0 100","Cashmod",$Cash::SaveInterest,0,0);
	RTB_registerPref("Brick Cost/Volume","Cash","$Cash::BrickCostPerVolume","int 0 5","Cashmod",$Cash::BrickCostPerVolume,0,0);
	$CashRTB = 1;
}
function CashStr(%amt,%mod)
{
	for(%i=0;%i<getwordcount(%mod);%i++)
	{
		if(getword(%mod,%i) $= "nocolor")
		{
			%nocolor = 1;
		}
		if(getword(%mod,%i) $= "full")
		{
			%full = 1;
		}
	}
	%amt = mFloatLength(%amt,2);
	if(%full)
	{
		%str = "\c6" @ $Cash::CurrencyName @ ": ";
	} else {
		%str = "";
	}
	if(!%nocolor)
	{
		%str = %str @ "<color:" @ $Cash::CurrencyColor @ ">";
	}
	if($Cash::CurrencyBefore)
	{
		%str = %str @ $Cash::Currency @ %amt;
	} else {
		%str = %str @ %amt @ $Cash::Currency;
	}
	return %str;
}
function CashObj::Load(%this,%id)
{
	if(!%this.Cleared)
	{
		%this.Clear();
	}
	%FO = new FileObject();
	if(!isFile("config/server/Cash.txt"))
	{
		%FO.openForWrite("config/server/Cash.txt");
		%FO.writeline("Cash save!");
		%FO.close();
	}
	if(%FO.openForRead("config/server/Cash.txt"))
	{
		%FO.readline();
		while(!%FO.isEOF())
		{
			%line = %FO.readLine();
			%lid = getField(%line,0);
			if(%lid $= %id)
			{
				%found = 1;
				%this.ID = %id;
				%this.Cash = getField(%line,1);
				%this.Bank = getField(%line,2);
				break;
			}
		}
		%FO.close();
	}
	if(!%found)
	{
		%this.ID = %id;
		%this.Cash = $Cash::DefaultCash;
		%this.Bank = $Cash::DefaultBank;
	}
	%this.Cleared = 0;
	%this.Save();
	if(isObject(findclientbybl_id(%id)))
	{
		%this.client = findclientbybl_id(%id);
		%this.client.cashobj = %this;
	}
	%FO.delete();
}
function CashObj::Save(%this)
{
	%FO = new FileObject();
	if(%FO.openForRead("config/server/Cash.txt"))
	{
		%FO.readline();
		while(!%FO.isEOF())
		{
			%temp[%lines] = %FO.readLine();
			if(getField(%temp[%lines],0) == %this.ID)
			{
				%temp[%lines] = %this.ID TAB %this.Cash TAB %this.Bank;
				%found = 1;
			}
			%lines++;
		}
		if(!%found)
		{
			%temp[%lines] = %this.ID TAB %this.Cash TAB %this.Bank;
			%lines++;
		}
		%FO.close();
		%this.Saved = 1;
	}
	if(%FO.openForWrite("config/server/Cash.txt"))
	{
		%FO.writeline("Cash save!");
		for(%i=0;%i<%lines;%i++)
		{
			%FO.writeline(%temp[%i]);
		}
		%FO.close();
	}
	%FO.delete();
	export("$Cash::*","config/server/CashPrefs.cs");
}
function CashObj::Clear(%this)
{
	%this.ID = "";
	%this.Cash = "";
	%this.Bank = "";
	%this.Cleared = 1;
	%this.Saved = 1;
	%this.client = "";
}
function CashObj::Mod(%this,%mode,%arg)
{
	%arg = mFloatLength(%arg,2);
	switch$(%mode)
	{
	case "cash":
		%this.Cash += %arg;
	case "scash":
		%this.Cash = %arg;
	case "bank":
		%this.Bank += %arg;
	case "sbank":
		%this.Bank = %arg;
	}
	%this.Saved = 0;
	if(isObject(%this.client))
	{
		%this.client.cashprint();
	}
}
registerOutputEvent(fxDTSbrick,"cashBank","bool",1);
registerOutputEvent(fxDTSbrick,"cashAdd","list Cash 0 Bank 1\tint -10000 10000 0",1);
if($AddOn__Event_Variables)
{
	registerOutputEvent(fxDTSbrick,"cashTransfer","string 200 96\tint 1 10000 1",1);
	registerOutputEvent(fxDTSbrick,"ifPlayerCash","list Cash 0 Bank 1\tlist Equals 0 NotEquals 1 Greater 2 Less 3 GreaterEquals 4 LessEquals 5\tstring 200 64",1);
} else {
	echo("Script_CashModII: Event_Variables is not enabled. cashTransfer and ifPlayerCash events will not be available.");
}
function fxDTSbrick::cashAdd(%brick,%list,%amt,%client)
{
	if(getbrickgroupfromobject(%brick).isAdmin)
	{
		if(%list)
		{
			%client.cashObj.mod("Bank",%amt);
		} else {
			%client.cashObj.mod("Cash",%amt);
		}
	}
}
function fxDTSbrick::ifPlayerCash(%brick,%cashtype,%logic,%arg,%client)
{
	if(!$AddOn__Event_Variables)
	{
		return;
	}
	if(%cashtype)
	{
		%amt = %client.cashobj.Bank;
	} else {
		%amt = %client.cashobj.Cash;
	}
	%arg = mFloor(%arg);
	if(!%arg > 0)
	{
		return;
	}
	switch(%logic)
	{
	case 0:
		if(%amt $= %arg)
		{
			%brick.VariableTrue(%client);
		} else {
			%brick.VariableFalse(%client);
		}
	case 1:
		if(%amt !$= %arg)
		{
			%brick.VariableTrue(%client);
		} else {
			%brick.VariableFalse(%client);
		}
	case 2:
		if(%amt > %arg)
		{
			%brick.VariableTrue(%client);
		} else {
			%brick.VariableFalse(%client);
		}
	case 3:
		if(%amt < %arg)
		{
			%brick.VariableTrue(%client);
		} else {
			%brick.VariableFalse(%client);
		}
	case 4:
		if(%amt >= %arg)
		{
			%brick.VariableTrue(%client);
		} else {
			%brick.VariableFalse(%client);
		}
	case 5:
		if(%amt <= %arg)
		{
			%brick.VariableTrue(%client);
		} else {
			%brick.VariableFalse(%client);
		}
	}
}
function fxDTSbrick::CashBank(%brick,%bool,%client)
{
	if(%client.CashBank)
	{
		return;
	}
	if(!%bool)
	{
		if(isObject(getbrickgroupfromobject(%brick).client))
		{
			if(!getbrickgroupfromobject(%brick).client.isAdmin)
			{
				%bool = 1;
			}
		} else {
			if(!getbrickgroupfromobject(%brick).isAdmin)
			{
				%bool = 1;
			}
		}
	}
	%client.CashBank = 1;
	%client.CashBankType = "ATM";
	%client.CashBankStage = "Menu";
	messageClient(%client,'',"\c6Banking: You have" SPC CashStr(%client.cashObj.Bank,"") @ "\c6.");
	if(!%bool)
	{
		messageClient(%client,'',"\c3  1\c6. Withdraw");
		messageClient(%client,'',"\c3  2\c6. Deposit");
		messageClient(%client,'',"\c3  3\c6. Transfer");
		%client.CashBankType = "Bank";
	} else {
		messageClient(%client,'',"\c6  Enter an amount to withdraw:");
		%client.CashBankStage = "Withdraw";
	}
}
function fxDTSbrick::CashTransfer(%brick,%reason,%amount,%client)
{
	if(!$AddOn__Event_Variables)
	{
		return;
	}
	if(%client.cashObj.Cash >= %amount)
	{
		%client.CashTransferBrick = %brick;
		%client.CashTransferAmount = %amount;
		messageClient(%client,'',"\c6A service requests a fee of" SPC CashStr(%amount,"") @ "\c6:");
		messageClient(%client,'',"\c3\"" @ %reason @ "\"");
		messageClient(%client,'',"\c6Use \c3/yes\c6 or \c3/no\c6 to interact.");
	} else {
		messageClient(%client,'',"\c6A service requests a fee of" SPC CashStr(%amount,"") @ "\c6:");
		messageClient(%client,'',"\c3\"" @ %reason @ "\"");
		messageClient(%client,'',"\c0!\c6 You do not have enough money to interact.");
	}
}
function servercmdyes(%client)
{
	if(!$AddOn__Event_Variables)
	{
		return;
	}
	if(isObject(%client.CashTransferBrick))
	{
		if(%client.cashObj.Cash >= %client.CashTransferAmount)
		{
			%client.CashObj.Mod("cash",0 - %client.CashTransferAmount);
			%id = getbrickgroupfromobject(%client.cashtransferbrick).bl_id;
			if(isObject(findclientbybl_id(%id)))
			{
				findclientbybl_id(%id).cashObj.mod("bank",%client.cashtransferamount);
			} else {
				%FO = new FileObject();
				if(%FO.openForRead("config/server/Cash.txt"))
				{
					%FO.readline();
					while(!%FO.isEOF())
					{
						%temp[%lines] = %FO.readline();
						if(getField(%temp[%lines],0) $= %id)
						{
							%temp[%lines] = getField(%temp[%lines],0) TAB getField(%temp[%lines],1) TAB getField(%temp[%lines],2) + %client.cashtransferamount;
						}
						%lines++;
					}
					%FO.close();
				}
				if(%FO.openForWrite("config/server/Cash.txt"))
				{
					%FO.writeline("Cash save!");
					for(%i=0;%i<%lines;%i++)
					{
						%FO.writeline(%temp[%i]);
					}
					%FO.close();
				}
				%FO.delete();
			}
			%client.CashTransferBrick.VariableTrue(%client);
		}
		%client.CashTransferBrick = "";
		%client.CashTransferAmount = "";
	}
}
function servercmdno(%client)
{
	if(!$AddOn__Event_Variables)
	{
		return;
	}
	if(isObject(%client.CashTransferBrick))
	{
		%client.CashTransferBrick.VariableFalse(%client);
		%client.CashTransferBrick = "";
		%client.CashTransferAmount = "";
	}
}
function servercmdgive(%client,%amt)
{
	if(%amt < 1 || %client.cashObj.cash < %amt)
	{
		messageClient(%client,'',"\c6You must enter a valid amount of money to give.");
		return;
	}
	%this = %client.player;
	%target = containerRayCast(%this.getEyePoint(),vectorAdd(vectorScale(vectorNormalize(%this.getEyeVector()),8),%this.getEyePoint()),$typeMasks::fxBrickObjectType | $typeMasks::PlayerObjectType);
	if(isObject(%target) && %target.getClassName() $= "Player")
	{
		%tarcl = %target.client;
		if(!isObject(%tarcl))
		{
			return;
		}
		%client.cashObj.mod("Cash",0 - %amt);
		%tarcl.cashObj.mod("Cash",%amt);
		messageclient(%client,'',"\c6You give" SPC CashStr(%amt,"") SPC "\c6to" SPC %tarcl.name @ ".");
		messageclient(%tarcl,'',"\c6You receive" SPC CashStr(%amt,"") SPC "\c6from" SPC %client.name @ ".");
	} else {
		messageClient(%client,'',"\c6You must be looking at and close to the target to give them money.");
	}
}
function servercmdreset(%c,%name)
{
	if(!%c.isAdmin)
	{
		if(%name !$= "")
		{
			messageClient(%c,'',"\c6You need to be an Admin to reset others. Use \c2/reset\c6 alone to reset yourself.");
		} else {
			%c.cashObj.mod("scash",$Cash::DefaultCash);
			%c.cashObj.mod("sbank",$Cash::DefaultBank);
			messageClient(%c,'',"\c6You have reset yourself.");
		}
	} else {
		if(%name $= "")
		{
			%c.cashObj.mod("scash",$Cash::DefaultCash);
			%c.cashObj.mod("sbank",$Cash::DefaultBank);
			messageClient(%c,'',"\c6You have reset yourself.");
		} else {
			%tar = findclientbyname(%name);
			if(isObject(%tar))
			{
				%tar.cashObj.mod("scash",$Cash::DefaultCash);
				%tar.cashObj.mod("sbank",$Cash::DefaultBank);
				messageclient(%c,'',"\c6You have reset \c3" @ %tar.name @ "\c6.");
				messageclient(%tar,'',"\c6You have been reset by \c3" @ %c.name @ "\c6.");
			} else {
				messageclient(%c,'',"\c6No client was found by the name of \c3" @ %name @ "\c6.");
			}
		}
	}
}
function servercmdgrant(%client,%amt,%name)
{
	if(!%client.isAdmin)
	{
		messageclient(%client,'',"\c6You need to be admin to grant.");
		return;
	}
	if(%amt < 1)
	{
		messageClient(%client,'',"\c6You must enter a valid amount of money to grant.");
		return;
	}
	if(%name $= "")
	{
		%this = %client.player;
		%target = containerRayCast(%this.getEyePoint(),vectorAdd(vectorScale(vectorNormalize(%this.getEyeVector()),8),%this.getEyePoint()),$typeMasks::fxBrickObjectType | $typeMasks::PlayerObjectType);
		if(isObject(%target) && %target.getClassName() $= "Player")
		{
			%tarcl = %target.client;
			if(!isObject(%tarcl))
			{
				return;
			}
			%tarcl.cashObj.mod("Bank",%amt);
			messageclient(%client,'',"\c6You grant" SPC CashStr(%amt,"") SPC "\c6to" SPC %tarcl.name @ ".");
			messageclient(%tarcl,'',"\c6You have been grants" SPC CashStr(%amt,"") SPC "\c6by" SPC %client.name @ ". It's in your bank.");
		} else {
			messageClient(%client,'',"\c6You must be looking at and close to the target to give them money.");
		}
	} else {
		if(%name $= "me")
		{
			%tarcl = %client;
		} else {
			%tarcl = findclientbyname(%name);
		}
		if(!isObject(%tarcl))
		{
			return;
		}
		%tarcl.cashObj.mod("Bank",%amt);
		if(%tarcl == %client)
		{
			messageclient(%client,'',"\c6You have granted" SPC CashStr(%amt,"") SPC "\c6to yourself. It's in your bank.");
		} else {
			messageclient(%client,'',"\c6You grant" SPC CashStr(%amt,"") SPC "\c6to" SPC %tarcl.name @ ".");
			messageclient(%tarcl,'',"\c6You have been grants" SPC CashStr(%amt,"") SPC "\c6by" SPC %client.name @ ". It's in your bank.");
		}
	}
}
function servercmddrop(%client,%amt)
{
	if(%amt < 1 || %client.cashobj.cash < %amt)
	{
		messageclient(%client,'',"\c6You need to enter a valid amount of money to drop.");
		return;
	}
	if(%amt > $Cash::MaxDrop)
	{
		%amt = $Cash::MaxDrop;
	}
	%cash = new Item()
	{
		datablock = nametoid("dropcashItem");
		canPickup = false;
		value = %amt;
	};
	%cash.setScale("0.6 0.6 0.6");
	%cash.setShapeNameColor($Cash::CurrencyItemColor);
	%cash.setShapeNameDistance(10);
	%client.cashobj.mod("cash",0 - %amt);
	%cash.setTransform(setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 2));
	%cash.setVelocity(VectorAdd(%client.player.getVelocity(),VectorScale(%client.player.getEyeVector(), 10)));
	MissionCleanup.add(%cash);
	%cash.setShapeName(CashStr(%cash.value,"nocolor"));
}	
package CashPackage
{
	function servercmdmessagesent(%c,%msg)
	{
		if(!%c.CashBank)
		{
			Parent::servercmdmessagesent(%c,%msg);
		} else {
			switch$(%c.CashBankStage)
			{
			case "Menu":
				%msg = mFloor(getword(%msg,0));
				switch(%msg)
				{
				case 1:
					%c.CashBankStage = "Withdraw";
					messageClient(%c,'',"\c6  Please enter an amount to withdraw:");
				case 2:
					%c.CashBankStage = "Deposit";
					messageClient(%c,'',"\c6  Please enter an amount to deposit:");
				case 3:
					%c.CashBankStage = "TransferTarget";
					messageClient(%c,'',"\c6  Please enter the BL_ID of the target account:");
				default:
					messageClient(%c,'',"\c6  You have selected an invalid option.");
					%c.CashBank = 0;
				}
			case "Withdraw":
				%msg = mFloor(getword(%msg,0));
				if(%msg > 0 && %c.cashObj.Bank >= %msg)
				{
					%c.cashObj.Mod("Cash",%msg);
					%c.cashObj.Mod("Bank",0 - %msg);
					messageclient(%c,'',"\c6  You have withdrawn" SPC CashStr(%msg,"") @ "\c6.");
					%c.CashBank = 0;
				} else {
					messageclient(%c,'',"\c6  You have selected an invalid amount.");
					%c.CashBank = 0;
				}
			case "Deposit":
				%msg = mFloor(getword(%msg,0));
				if(%msg > 0 && %c.cashObj.Cash >= %msg)
				{
					%c.cashObj.Mod("Cash",0 - %msg);
					%c.cashObj.Mod("Bank",%msg);
					messageclient(%c,'',"\c6  You have deposited" SPC CashStr(%msg,"") @ "\c6.");
					%c.CashBank = 0;
				} else {
					messageclient(%c,'',"\c6  You have selected an invalid amount.");
					%c.CashBank = 0;
				}
			case "TransferTarget":
				if(isObject(findclientbybl_id(%msg)))
				{
					%c.CashTransTarget = findclientbybl_id(%msg);
					messageClient(%c,'',"\c6  Please enter an amount to transfer:");
					%c.CashBankStage = "TransferAmount";
				} else {
					messageClient(%c,'',"\c6  You have selected an invalid target.");
					%c.CashBank = 0;
				}
			case "TransferAmount":
				%msg = mFloor(getword(%msg,0));
				if(%msg > 0 && %c.cashObj.bank >= %msg)
				{
					%c.cashObj.Mod("Bank",0 - %msg);
					%c.CashTransTarget.cashObj.Mod("Bank",%msg);
					messageClient(%c,'',"\c6  You have sent" SPC CashStr(%msg,"") SPC "\c6to" SPC %c.CashTransTarget.name @ ".");
					%c.CashBank = 0;
				} else {
					messageClient(%c,'',"\c6  You have selected an invalid amount.");
					%c.CashBank = 0;
				}
			default:
				messageClient(%c,'',"\c6  Something is wrong.");
				%c.CashBank = 0;
			}
		}
	}
	function GameConnection::loadMission(%client,%a,%b,%c,%d,%e)
	{
		Parent::loadMission(%client,%a,%b,%c,%d,%e);
		if(!$CashStarted)
		{
			$CashStarted = 1;
			$Savetick = schedule($Cash::SaveTime * 60000,0,"SaveTick");
		}
		for(%i=0;%i<$CashObjs;%i++)
		{
			%obj = $CashObj[%i];
			if(isObject(%obj) && (%obj.ID $= "" || %obj.ID == %client.bl_id))
			{
				%obj.Clear();
				%obj.Load(%client.bl_id);
				%f = 1;
				break;
			}
		}
		if(!%f)
		{
			$CashObj[$CashObjs] = new ScriptObject() {
				class = "CashObj";
			};
			$CashObj[$CashObjs].clear();
			$CashObj[$CashObjs].Load(%client.bl_id);
			$CashObjs++;
		}
	}
	function GameConnection::cashPrint(%client)
	{
		%client.CashPrint = "<just:right>  <font:Palatino Linotype:16pt>" @ CashStr(%client.cashobj.cash,"full");
		commandtoclient(%client,'bottomprint',%client.CashPrint);
	}
	function GameConnection::bottomprint(%client,%str,%time)
	{
		if(%str $= "")
		{
			return;
		}
		cancel(%client.NSched);
		%pos = strpos(%str,"<br>");
		if(%pos != -1)
		{
			%str = getsubstr(%str,0,%pos);
		}
		%str = %str @ %client.cashprint;
		Parent::bottomprint(%client,%str,%time);
		%client.NSched = %client.schedule((%time * 1000) - 33,"cashprint");
	}
	function GameConnection::spawnPlayer(%client)
	{
		Parent::spawnPlayer(%client);
		%client.cashprint();
		if(%client.isAdmin)
		{
			%client.brickgroup.isAdmin = 1;
		}
	}
	function GameConnection::onClientLeaveGame(%client)
	{
		if(!%client.cashObj.Saved)
		{
			%client.cashObj.Save();
		}
		%client.cashObj.clear();
		if(%client.isAdmin)
		{
			%client.brickgroup.isAdmin = 1;
		} else {
			%client.brickgroup.isAdmin = 0;
		}
		Parent::onClientLeaveGame(%client);
	}
	function gameConnection::onDeath(%client,%killerPlayer,%killer,%damageType,%unknownA)
	{
		if($Cash::DropOnDeath)
		{
			if(%client.cashObj.cash > 0)
			{
				%cash = new Item()
				{
					datablock = nametoid("dropcashItem");
					canPickup = false;
					value = %client.cashObj.cash;
				};
				%cash.setScale("0.6 0.6 0.6");
				%cash.setShapeNameColor($Cash::CurrencyItemColor);
				%cash.setShapeNameDistance(10);
				%cash.setTransform(setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 2));
				%cash.setVelocity(VectorAdd(%client.player.getVelocity(),VectorScale(%client.player.getEyeVector(), 10)));
				MissionCleanup.add(%cash);
				%cash.setShapeName(CashStr(%cash.value,"nocolor"));
				%client.cashObj.mod("scash",0);
			}
		}
		Parent::onDeath(%client,%killerPlayer,%killer,%damageType,%unknownA);
	}
	function Armor::onCollision(%this,%obj,%col,%thing,%other)
	{
		if(%col.getDatablock().getName() $= "dropcashitem")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					%obj.client.cashObj.Mod("cash",%col.value);
					messageClient(%obj.client, '', "\c6You have picked up" SPC CashStr(%col.value,"") @ "\c6.");
					%col.canPickup = false;
					%col.delete();
					
					return;
				} else {
					%col.delete();
					MissionCleanup.remove(%col);
				}
			}
		} else {
			Parent::onCollision(%this,%obj,%col,%thing,%other);
		}
	}
	function fxDTSbrick::Plant(%brick)
	{
		%e = Parent::Plant(%brick);
		if(!%e)
		{
			%c = getbrickgroupfromobject(%brick).client;
			if(isObject(%c) && isObject(%c.player) && isObject(%c.player.tempbrick))
			{
				%vol = %c.player.tempbrick.getVolume();
				%cost = $Cash::BrickCostPerVolume / 10;
				%amt = mFloatLength(%c.cashObj.cash,2);
				if(%amt < %cost * %vol)
				{
					commandtoclient(%c,'centerprint',"\c6You need" SPC CashStr(%cost * %vol,"") SPC "\c6to plant this brick.",2);
					%brick.schedule(0,"delete");
				} else {
					%c.cashObj.mod("Cash",0 - (%cost * %vol));
				}
			}
		}
	}
};
ActivatePackage(CashPackage);
function fxDTSbrick::getVolume(%brick)
{
	%db = %brick.getDatablock();
	return %db.brickSizeX * %db.brickSizeY * %db.brickSizeZ;
}
function servercmdcashsave(%c)
{
	%c.cashObj.save();
	commandtoclient(%c,'centerprint',"\c6Cash saved!",3);
}
function SaveTick()
{
	cancel($Savetick);
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%c = ClientGroup.getObject(%i);
		if(isObject(%c.cashObj))
		{
			%amt = %c.cashObj.Bank;
			%amt = mFloor(%amt + ((%amt / 100) * $Cash::SaveInterest));
			%c.cashObj.Bank = %amt;
			%c.cashObj.Mod("cash",$Cash::SaveIncome);
			%c.cashObj.save();
			commandtoclient(%c,'centerprint',"\c6Cash auto-saved!",3);
		}
	}
	$Savetick = schedule($Cash::SaveTime * 60000,0,"SaveTick");
}
datablock ItemData(dropcashItem)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "base/data/shapes/brickWeapon.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	doColorShift = true;
	colorShiftColor = "0 0.5 0 1";
	image = dropcashImage;
	candrop = true;
	canPickup = false;
};
datablock ShapeBaseImageData(dropcashImage)
{
	shapeFile = "base/data/shapes/brickWeapon.dts";
	emap = true;
	
	doColorShift = true;
	colorShiftColor = dropCashItem.colorshiftcolor;
	canPickup = false;
};